//+------------------------------------------------------------------+
//|                                                        Bulls.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//mod
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DarkGreen
#property indicator_color2 Maroon
#property indicator_color3 Blue
#property indicator_color4 DarkOrange
#property indicator_width1 2  
#property indicator_style3 2  
#property indicator_style4 2  

//---- input parameters
extern int BullsBearsPeriod=13;
extern int BullsBearsMAPeriod=5;
extern int SignalSMA=3;
//---- buffers
double BullsBuffer[];
double BearsBuffer[];
double BullsSignal[];
double BearsSignal[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(5);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(0,BullsBuffer);
   SetIndexBuffer(1,BearsBuffer);
   SetIndexBuffer(2,BullsSignal);
   SetIndexBuffer(3,BearsSignal);
   SetIndexBuffer(4,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="BullsBears ("+BullsBearsPeriod+") ma "+BullsBearsMAPeriod;
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=BullsBearsPeriod) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      TempBuffer[i]=iMA(NULL,0,BullsBearsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      BullsBuffer[i]=iMA(NULL,0,BullsBearsMAPeriod,0,MODE_EMA,PRICE_HIGH,i)-TempBuffer[i];
      BearsBuffer[i]=iMA(NULL,0,BullsBearsMAPeriod,0,MODE_EMA,PRICE_LOW,i) -TempBuffer[i];
 
 
      i--;
     }
     
     //----
   i=Bars-counted_bars-1;
   while(i>=0)
     {      
      BullsSignal[i]=iMAOnArray(BullsBuffer,Bars,SignalSMA,0,MODE_SMA,i);
      BearsSignal[i]=iMAOnArray(BearsBuffer,Bars,SignalSMA,0,MODE_SMA,i);
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+